
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "rif_rgb.h"
#include "sif.h"
#include "sif_rgb.h"

extern void	Error();

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	Nx,Ny,BPS,Nh,Nv,v,y1,y2,h,x1,x2,gray=1;
	Cell	**oR,**oG,**oB,**nR,**nG,**nB,r,g,b;
	double	Bx,By,x,y,ratio,xy,C,Cx,Cy;
	char	*bbs="bad block size.";

	if (argc!=4 && argc!=5) Error("usage : pne_RGB orgTIFF Bxy newTIFF\n"
				      "        pne_RGB orgTIFF Bx By newTIFF");

	ReadImageFile_RGB(argv[1],&Nx,&Ny,&BPS,&oR,&oG,&oB,NULL);

	if (argc==4) {
	    if ((Bx=By=atof(argv[2]))<1.0) Error(bbs);
	}
	else
	    if ((Bx=atof(argv[2]))<1.0 ||
		(By=atof(argv[3]))<1.0) Error(bbs);

	Nh=(int)(x=Bx*(double)Nx); if (x>(double)Nh) ++Nh;
	Nv=(int)(y=By*(double)Ny); if (y>(double)Nv) ++Nv;

	if ((nR=(Cell **)malloc(sizeof(Cell *)*(size_t)Nv))==NULL ||
	    (nG=(Cell **)malloc(sizeof(Cell *)*(size_t)Nv))==NULL ||
	    (nB=(Cell **)malloc(sizeof(Cell *)*(size_t)Nv))==NULL ||
	    (*nR=(Cell *)malloc(sizeof(Cell)*(size_t)Nv*(size_t)Nh))==NULL ||
	    (*nG=(Cell *)malloc(sizeof(Cell)*(size_t)Nv*(size_t)Nh))==NULL ||
	    (*nB=(Cell *)malloc(sizeof(Cell)*(size_t)Nv*(size_t)Nh))==NULL)
	    Error("no allocatable memory for new cell.");

	ratio=255.0/(double)((1<<BPS)-1);

	for (v=0; v<Nv; v++) {
	    if (v!=0) {
		nR[v]=nR[v-1]+Nh; nG[v]=nG[v-1]+Nh; nB[v]=nB[v-1]+Nh;
	    }
	    if ((y=((double)v+0.5)/By)<0.5) {
		y-=(-0.5); y1=y2=0;
	    }
	    else if (y>=(double)Ny-0.5) {
		y-=((double)Ny-0.5); y1=y2=Ny-1;
	    }
	    else
		y-=((double)(y1=(y2=(int)(y+0.5))-1)+0.5);

	    for (h=0; h<Nh; h++) {
		if ((x=((double)h+0.5)/Bx)<0.5) {
		    x-=(-0.5); x1=x2=0;
		}
		else if (x>=(double)Nx-0.5) {
		    x-=((double)Nx-0.5); x1=x2=Nx-1;
		}
		else
		    x-=((double)(x1=(x2=(int)(x+0.5))-1)+0.5);

		xy=x*y;

#define RGB(rgb,n,o)	\
	C=(double)o[y1][x1]; \
	Cx=(double)o[y1][x2]-C; \
	Cy=(double)o[y2][x1]-C; \
	rgb=n[v][h]=(Cell)(ratio*(C+Cx*x \
				   +Cy*y \
				   +((double)o[y2][x2]-C-Cx-Cy)*xy)+0.5)

		RGB(r,nR,oR);
		RGB(g,nG,oG);
		RGB(b,nB,oB); if (gray) gray=r==g && r==b;
	    }
	}
	if (gray)
	    StoreImageFile(argv[argc-1],Nh,Nv,8,nR,NULL);
	else
	    StoreImageFile_RGB(argv[argc-1],Nh,Nv,8,nR,nG,nB,NULL);

	return 0;
}
