
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "rif.h"
#include "sif.h"

extern void	Error();

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	Nx,Ny,BPS,Nh,Nv,v,y1,y2,h,x1,x2;
	Cell	**org,**new;
	double	Bx,By,x,y,C,Cx,Cy;
	char	*bbs="bad block size.";

	if (argc!=4 && argc!=5) Error("usage : pne_gray orgTIFF Bxy newTIFF\n"
				      "        pne_gray orgTIFF Bx By newTIFF");

	ReadImageFile(argv[1],&Nx,&Ny,&BPS,&org,NULL);

	if (argc==4) {
	    if ((Bx=By=atof(argv[2]))<1.0) Error(bbs);
	}
	else
	    if ((Bx=atof(argv[2]))<1.0 ||
		(By=atof(argv[3]))<1.0) Error(bbs);

	Nh=(int)(x=Bx*(double)Nx); if (x>(double)Nh) ++Nh;
	Nv=(int)(y=By*(double)Ny); if (y>(double)Nv) ++Nv;

	if ((new=(Cell **)malloc(sizeof(Cell *)*(size_t)Nv))==NULL ||
	    (*new=(Cell *)malloc(sizeof(Cell)*(size_t)Nv*(size_t)Nh))==NULL)
	    Error("no allocatable memory for new cell.");

	for (v=0; v<Nv; v++) {
	    if (v!=0) new[v]=new[v-1]+Nh;

	    if ((y=((double)v+0.5)/By)<0.5) {
		y-=(-0.5); y1=y2=0;
	    }
	    else if (y>=(double)Ny-0.5) {
		y-=((double)Ny-0.5); y1=y2=Ny-1;
	    }
	    else
		y-=((double)(y1=(y2=(int)(y+0.5))-1)+0.5);

	    for (h=0; h<Nh; h++) {
		if ((x=((double)h+0.5)/Bx)<0.5) {
		    x-=(-0.5); x1=x2=0;
		}
		else if (x>=(double)Nx-0.5) {
		    x-=((double)Nx-0.5); x1=x2=Nx-1;
		}
		else
		    x-=((double)(x1=(x2=(int)(x+0.5))-1)+0.5);

		C=(double)org[y1][x1];
		Cx=(double)org[y1][x2]-C;
		Cy=(double)org[y2][x1]-C;
		new[v][h]=(Cell)(C+Cx*x
				  +Cy*y
				  +((double)org[y2][x2]-C-Cx-Cy)*x*y+0.5);
	    }
	}
	StoreImageFile(argv[argc-1],Nh,Nv,BPS,new,NULL);

	return 0;
}
