
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "rif.h"
#include "sif.h"

extern void	Error();

#define ADD0(SUM,RX,CELL)	SUM+=((RX)*(CELL))

static int	Nx;
static double	Bx;

static void	Add1(sum,Ry,cell)
double		*sum,Ry;
Cell		*cell;
{
	int	x,h=(-1),next=1;
	double	Rx,last=0.0;

	for (Rx=0.0, x=0; x<Nx; x++, Rx-=1.0) {
	    if (next) {
		ADD0(sum[++h],-Rx,last); Rx+=Bx;
	    }
	    ADD0(sum[h],(next=Rx<=1.0)?Rx:1.0,last=Ry*(double)cell[x]);
	}
}

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	Ny,BPS,Nh,H,Nv,V,v,h,y,next;
	Cell	**cell,*last;
	double	By,**sum,Ry,factor,Ax,Ay;
	char	*bbs="bad block size.";

	if (argc!=4 && argc!=5) Error("usage : pnr_gray orgTIFF Bxy newTIFF\n"
				      "        pnr_gray orgTIFF Bx By newTIFF");

	ReadImageFile(argv[1],&Nx,&Ny,&BPS,&cell,NULL);

	if (argc==4) {
	    if ((Bx=By=atof(argv[2]))<1.0) Error(bbs);
	}
	else
	    if ((Bx=atof(argv[2]))<1.0 ||
		(By=atof(argv[3]))<1.0) Error(bbs);

	Nh=(H=(int)((double)(Nx-1)/Bx))+1;
	Nv=(V=(int)((double)(Ny-1)/By))+1;

	if ((sum=(double **)malloc(sizeof(double *)*(size_t)Nv))==NULL ||
	    (*sum=(double *)malloc(sizeof(double)*(size_t)Nv*(size_t)Nh))==NULL)
	    Error("no allocatable memory for sum.");

	for (v=0; v<Nv; v++) {
	    if (v!=0) sum[v]=sum[v-1]+Nh;

	    for (h=0; h<Nh; h++) sum[v][h]=0.0;
	}
	v=(-1); last=cell[0]; next=1;
	for (Ry=0.0, y=0; y<Ny; y++, Ry-=1.0) {
	    if (next) {
		Add1(sum[++v],-Ry,last); Ry+=By;
	    }
	    Add1(sum[v],(next=Ry<=1.0)?Ry:1.0,last=cell[y]);
	}
	factor=1.0/Bx/By;
	for (v=0; v<V; v++)
	for (h=0; h<H; h++) cell[v][h]=(Cell)(sum[v][h]*factor+0.5);

	factor=1.0/(Ax=(double)Nx-Bx*(double)H)/By;
	for (v=0; v<V; v++) cell[v][H]=(Cell)(sum[v][H]*factor+0.5);

	factor=1.0/Bx/(Ay=(double)Ny-By*(double)V);
	for (h=0; h<H; h++) cell[V][h]=(Cell)(sum[V][h]*factor+0.5);

	cell[V][H]=(Cell)(sum[V][H]/Ax/Ay+0.5);

	StoreImageFile(argv[argc-1],Nh,Nv,BPS,cell,NULL);

	return 0;
}
