
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "rif_rgb.h"
#include "sif.h"
#include "sif_rgb.h"

extern void	Error();

static int	Axis(hv,x,y)
char		*hv;
int		*x,*y;
{
	int	pm=(hv[0]=='+')?1:(hv[0]=='-')?-1:0;

	if (pm)
	    switch(hv[1]) {
		case 'x': case 'X': *x=pm; *y=0; return 'x';
		case 'y': case 'Y': *y=pm; *x=0; return 'y';
	    }

	return 0;
}

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	Nx,Ny,BPS,h,hx,hy,v,vx,vy,Nh,h0,Nv,v0,y,x,gray=1;
	Cell	**oR,**oG,**oB,**nR,**nG,**nB,r,g,b;
	double	ratio;

	if (argc!=5) Error("usage : rar_RGB orgTIFF hAxis vAxis newTIFF");

	ReadImageFile_RGB(argv[1],&Nx,&Ny,&BPS,&oR,&oG,&oB,NULL);

	if (!(h=Axis(argv[2],&hx,&hy)) ||
	    !(v=Axis(argv[3],&vx,&vy)) || h==v) Error("bad axial direction.");

	if ((Nh=hx*Nx+hy*Ny)>0) h0=0; else h0=(Nh=(-Nh))-1;
	if ((Nv=vx*Nx+vy*Ny)>0) v0=0; else v0=(Nv=(-Nv))-1;

	if ((nR=(Cell **)malloc(sizeof(Cell *)*(size_t)Nv))==NULL ||
	    (nG=(Cell **)malloc(sizeof(Cell *)*(size_t)Nv))==NULL ||
	    (nB=(Cell **)malloc(sizeof(Cell *)*(size_t)Nv))==NULL ||
	    (*nR=(Cell *)malloc(sizeof(Cell)*(size_t)Nv*(size_t)Nh))==NULL ||
	    (*nG=(Cell *)malloc(sizeof(Cell)*(size_t)Nv*(size_t)Nh))==NULL ||
	    (*nB=(Cell *)malloc(sizeof(Cell)*(size_t)Nv*(size_t)Nh))==NULL)
	    Error("no allocatable memory for cell.");

	for (v=1; v<Nv; v++) {
	    nR[v]=nR[v-1]+Nh; nG[v]=nG[v-1]+Nh; nB[v]=nB[v-1]+Nh;
	}
	ratio=255.0/(double)((1<<BPS)-1);

	for (y=0; y<Ny; y++)
	for (x=0; x<Nx; x++) {
	    h=hx*x+hy*y+h0;
	    v=vx*x+vy*y+v0;
	    r=nR[v][h]=(Cell)(ratio*(double)oR[y][x]+0.5);
	    g=nG[v][h]=(Cell)(ratio*(double)oG[y][x]+0.5);
	    b=nB[v][h]=(Cell)(ratio*(double)oB[y][x]+0.5);
	    if (gray) gray=r==g && r==b;
	}
	if (gray)
	    StoreImageFile(argv[4],Nh,Nv,8,nR,NULL);
	else
	    StoreImageFile_RGB(argv[4],Nh,Nv,8,nR,nG,nB,NULL);

	return 0;
}
