
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "rif.h"
#include "sif.h"

extern void	Error();

static int	Axis(hv,x,y)
char		*hv;
int		*x,*y;
{
	int	pm=(hv[0]=='+')?1:(hv[0]=='-')?-1:0;

	if (pm)
	    switch(hv[1]) {
		case 'x': case 'X': *x=pm; *y=0; return 'x';
		case 'y': case 'Y': *y=pm; *x=0; return 'y';
	    }

	return 0;
}

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	Nx,Ny,BPS,h,hx,hy,v,vx,vy,Nh,h0,Nv,v0,y,x;
	Cell	**org,**new;

	if (argc!=5) Error("usage : rar_gray orgTIFF hAxis vAxis newTIFF");

	ReadImageFile(argv[1],&Nx,&Ny,&BPS,&org,NULL);

	if (!(h=Axis(argv[2],&hx,&hy)) ||
	    !(v=Axis(argv[3],&vx,&vy)) || h==v) Error("bad axial direction.");

	if ((Nh=hx*Nx+hy*Ny)>0) h0=0; else h0=(Nh=(-Nh))-1;
	if ((Nv=vx*Nx+vy*Ny)>0) v0=0; else v0=(Nv=(-Nv))-1;

	if ((new=(Cell **)malloc(sizeof(Cell *)*(size_t)Nv))==NULL ||
	    (*new=(Cell *)malloc(sizeof(Cell)*(size_t)Nv*(size_t)Nh))==NULL)
	    Error("no allocatable memory for cell.");

	for (v=1; v<Nv; v++) new[v]=new[v-1]+Nh;

	for (y=0; y<Ny; y++)
	for (x=0; x<Nx; x++) new[vx*x+vy*y+v0][hx*x+hy*y+h0]=org[y][x];

	StoreImageFile(argv[4],Nh,Nv,BPS,new,NULL);

	return 0;
}
