
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "cell.h"
#include "csi.h"

extern void	Error(),ReadSliceImage();

int	main(argc,argv)
int	argc;
char	**argv;
{
	char	**paths,*bbs="bad block size.";
	int	Nx,Ny,Nz,Bx,By,Bz,y,H,Nh,V,Nv,v,h,z,x,d;
	Cell	**cell;
	double	**sum1,**sum2,xy,hy,xv,hv,N0,N1,N2,N3,N;

	if (argc!=4 && argc!=6)
	    Error("usage : si_dmp directory nameFile Bxyz\n"
		  "        si_dmp directory nameFile Bx By Bz");

	paths=CheckSliceImages(argv[1],argv[2],&Nx,&Ny,&Nz,NULL);

	if (argc==4) {
	    if ((Bx=By=Bz=atoi(argv[3]))<=0) Error(bbs);
	}
	else
	    if ((Bx=atoi(argv[3]))<=0 ||
		(By=atoi(argv[4]))<=0 ||
		(Bz=atoi(argv[5]))<=0) Error(bbs);

#define ALLOC(type,noe)	(type *)malloc(sizeof(type)*(noe))

	if ((cell=ALLOC(Cell *,(size_t)Ny))==NULL ||
	    (*cell=ALLOC(Cell,(size_t)Ny*(size_t)Nx))==NULL)
	    Error("no allocatable memory for cell.");

	for (y=1; y<Ny; y++) cell[y]=cell[y-1]+Nx;

	Nh=(H=(Nx-1)/Bx)+1;
	Nv=(V=(Ny-1)/By)+1;

	if ((sum1=ALLOC(double *,(size_t)Nv))==NULL ||
	    (sum2=ALLOC(double *,(size_t)Nv))==NULL ||
	    (*sum1=ALLOC(double,(size_t)Nv*(size_t)Nh))==NULL ||
	    (*sum2=ALLOC(double,(size_t)Nv*(size_t)Nh))==NULL)
	    Error("no allocatable memory for sum.");

	for (v=1; v<Nv; v++) {
	    sum1[v]=sum1[v-1]+Nh; sum2[v]=sum2[v-1]+Nh;
	}
	xy=(double)Bx*(double)By;
	h=(Nx-1)%Bx+1; hy=(double)h*(double)By;
	v=(Ny-1)%By+1; xv=(double)Bx*(double)v; hv=(double)h*(double)v;

	for (z=0; z<Nz; z++) {
	    ReadSliceImage(paths[z],Nx,Ny,cell);

	    if (z%Bz==0)
		for (v=0; v<Nv; v++)
		for (h=0; h<Nh; h++) sum1[v][h]=sum2[v][h]=0.0;

	    for (y=0; y<Ny; y++) {
		v=y/By;
		for (x=0; x<Nx; x++) {
		    h=x/Bx;
		    sum1[v][h]+=(double)cell[y][x];
		    sum2[v][h]+=((double)cell[y][x]*(double)cell[y][x]);
		}
	    }
	    if ((z+1)%Bz==0 || z+1==Nz) {
		N0=xy*(double)(d=z%Bz+1);
		N1=hy*(double)d;
		N2=xv*(double)d;
		N3=hv*(double)d;
		d=z/Bz;
		for (v=0; v<Nv; v++)
		for (h=0; h<Nh; h++) {
		    (void)printf("%d\t%d\t%d\t",h,v,d);
		    if ((N=(v==V)?(h==H)?N3:N2:(h==H)?N1:N0)<2.0)
			(void)printf("%d\n",(int)sum1[v][h]);
		    else
			(void)printf("%d\t%lf\t%lf\n",
	(int)N,sum1[v][h]/N,sqrt(fabs(sum2[v][h]-sum1[v][h]*sum1[v][h]/N)/N));
		}
	    }
	}
	return 0;
}
