
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "csi.h"
#include "sif.h"

extern void	Error(),ReadSliceImage();

#define LEN	1024

int	main(argc,argv)
int	argc;
char	**argv;
{
	char	**paths,form[LEN],path[LEN],*bbs="bad block size.";
	int	Nx,Ny,Nz,BPS,Nh,Nv,Nd,v,d,z1,h,z2,y1,y2,x1,x2;
	double	Bx,By,Bz,x,y,z,C,Cx,Cy,Cz,Cxy,Cyz,Czx;
	Cell	**o1,**o2,**new,**O1,**O2,**o;

	if (argc!=5 && argc!=7)
	    Error("usage : si_pne orgDir nameFile Bxyz newDir\n"
		  "        si_pne orgDir nameFile Bx By Bz newDir");

	paths=CheckSliceImages(argv[1],argv[2],&Nx,&Ny,&Nz,&BPS);

	if (argc==5) {
	    if ((Bx=By=Bz=atof(argv[3]))<1.0) Error(bbs);
	}
	else
	    if ((Bx=atof(argv[3]))<1.0 ||
		(By=atof(argv[4]))<1.0 ||
		(Bz=atof(argv[5]))<1.0) Error(bbs);

	Nh=(int)(x=Bx*(double)Nx); if (x>(double)Nh) ++Nh;
	Nv=(int)(y=By*(double)Ny); if (y>(double)Nv) ++Nv;
	Nd=(int)(z=Bz*(double)Nz); if (z>(double)Nd) ++Nd;

	if ((o1=(Cell **)malloc(sizeof(Cell *)*(size_t)Ny))==NULL ||
	    (o2=(Cell **)malloc(sizeof(Cell *)*(size_t)Ny))==NULL ||
	    (new=(Cell **)malloc(sizeof(Cell *)*(size_t)Nv))==NULL ||
	    (*o1=(Cell *)malloc(sizeof(Cell)*(size_t)Ny*(size_t)Nx))==NULL ||
	    (*o2=(Cell *)malloc(sizeof(Cell)*(size_t)Ny*(size_t)Nx))==NULL ||
	    (*new=(Cell *)malloc(sizeof(Cell)*(size_t)Nv*(size_t)Nh))==NULL)
	    Error("no allocatable memory for cell.");

	for (v=1; v<Nv; v++) {
	    if (v<Ny) {
		o1[v]=o1[v-1]+Nx;
		o2[v]=o2[v-1]+Nx;
	    }
	    new[v]=new[v-1]+Nh;
	}
{
	int	l=1;

	for (d=Nd-1; d>=10; d/=10) ++l;
	(void)sprintf(form,"%s/%%0%dd.tif",argv[argc-1],l);
}
	ReadSliceImage(paths[z1=0],Nx,Ny,o2);

	for (d=0; d<Nd; d++) {
	    if ((z=((double)d+0.5)/Bz)<0.5) {
		z-=(-0.5); O1=O2=o2;
	    }
	    else if (z>=(double)Nz-0.5) {
		z-=((double)Nz-0.5); O1=O2=o2;
	    }
	    else {
                z-=((double)((z2=(int)(z+0.5))-1)+0.5);

		if (z2>z1) {
		    o=o1; o1=o2; o2=o; ReadSliceImage(paths[z1=z2],Nx,Ny,o2);
		}
		O1=o1; O2=o2;
	    }
	    for (v=0; v<Nv; v++) {
		if ((y=((double)v+0.5)/By)<0.5) {
		    y-=(-0.5); y1=y2=0;
		}
		else if (y>=(double)Ny-0.5) {
		    y-=((double)Ny-0.5); y1=y2=Ny-1;
		}
		else
		    y-=((double)(y1=(y2=(int)(y+0.5))-1)+0.5);

		for (h=0; h<Nh; h++) {
		    if ((x=((double)h+0.5)/Bx)<0.5) {
			x-=(-0.5); x1=x2=0;
		    }
		    else if (x>=(double)Nx-0.5) {
			x-=((double)Nx-0.5); x1=x2=Nx-1;
		    }
		    else
			x-=((double)(x1=(x2=(int)(x+0.5))-1)+0.5);

		    C=(double)O1[y1][x1];
		    Cx=(double)O1[y1][x2]-C;
		    Cy=(double)O1[y2][x1]-C;
		    Cz=(double)O2[y1][x1]-C;
		    Cxy=(double)O1[y2][x2]-C-Cx-Cy;
		    Cyz=(double)O2[y2][x1]-C-Cy-Cz;
		    Czx=(double)O2[y1][x2]-C-Cz-Cx;
		    new[v][h]=(Cell)(C+Cx*x
				      +Cy*y
				      +Cz*z
				      +Cxy*x*y
				      +Cyz*y*z
				      +Czx*z*x
		    +((double)O2[y2][x2]-C-Cx-Cy-Cz-Cxy-Cyz-Czx)*x*y*z+0.5);
		}
	    }
	    (void)sprintf(path,form,d);
	    StoreImageFile(path,Nh,Nv,BPS,new,NULL);
	}
	return 0;
}
