
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "csi.h"
#include "sif.h"

extern void	Error(),ReadSliceImage();

#define ADD0(SUM,RX,CELL)	SUM+=((RX)*(CELL))

static int	Nx;
static double	Bx;

static void	Add1(sum,Ry,cell)
double		*sum,Ry;
Cell		*cell;
{
	int	x,h=(-1),next=1;
	double	Rx,last=0.0;

	for (Rx=0.0, x=0; x<Nx; x++, Rx-=1.0) {
	    if (next) {
		ADD0(sum[++h],-Rx,last); Rx+=Bx;
	    }
	    ADD0(sum[h],(next=Rx<=1.0)?Rx:1.0,last=Ry*(double)cell[x]);
	}
}

static int	Ny;
static double	By;

static void	Add2(sum,Rz,cell)
double		**sum,Rz;
Cell		**cell;
{
	int	y,v=(-1),next=1;
	Cell	*last=cell[0];
	double	Ry;

	for (Ry=0.0, y=0; y<Ny; y++, Ry-=1.0) {
	    if (next) {
		Add1(sum[++v],-Ry*Rz,last); Ry+=By;
	    }
	    Add1(sum[v],(next=Ry<=1.0)?Ry*Rz:Rz,last=cell[y]);
	}
}

#define LEN	1024

int	main(argc,argv)
int	argc;
char	**argv;
{
	char	**paths,form[LEN],path[LEN],*bbs="bad block size.";
	int	Nz,BPS,y,Nh,H,Nv,V,v,D,d,next,z,h,end;
	double	Bz,**sum,Ax,Ay,Rz,factor,Az;
	Cell	**last,**cell;

	if (argc!=5 && argc!=7)
	    Error("usage : si_pnr orgDir nameFile Bxyz newDir\n"
		  "        si_pnr orgDir nameFile Bx By Bz newDir");

	paths=CheckSliceImages(argv[1],argv[2],&Nx,&Ny,&Nz,&BPS);

	if (argc==5) {
	    if ((Bx=By=Bz=atof(argv[3]))<1.0) Error(bbs);
	}
	else
	    if ((Bx=atof(argv[3]))<1.0 ||
		(By=atof(argv[4]))<1.0 ||
		(Bz=atof(argv[5]))<1.0) Error(bbs);

	if ((last=(Cell **)malloc(sizeof(Cell *)*(size_t)Ny))==NULL ||
	    (*last=(Cell *)malloc(sizeof(Cell)*(size_t)Ny*(size_t)Nx))==NULL)
	    Error("no allocatable memory for cell.");

	for (y=1; y<Ny; y++) last[y]=last[y-1]+Nx;

	Nh=(H=(int)((double)(Nx-1)/Bx))+1;
	Nv=(V=(int)((double)(Ny-1)/By))+1;

	if ((sum=(double **)malloc(sizeof(double *)*(size_t)Nv))==NULL ||
	    (*sum=(double *)malloc(sizeof(double)*(size_t)Nv*(size_t)Nh))==NULL)
	    Error("no allocatable memory for sum.");

	for (v=1; v<Nv; v++) sum[v]=sum[v-1]+Nh;

	cell=(Cell **)sum;
	Ax=(double)Nx-Bx*(double)H;
	Ay=(double)Ny-By*(double)V;
	D=(int)((double)(Nz-1)/Bz);
{
	int	l=1;

	for (d=D; d>=10; d/=10) ++l;
	(void)sprintf(form,"%s/%%0%dd.tif",argv[argc-1],l);
}
	d=(-1); next=1;
	for (Rz=0.0, z=0; z<Nz; z++, Rz-=1.0) {
	    if (next) {
		for (v=0; v<Nv; v++)
		for (h=0; h<Nh; h++) sum[v][h]=0.0;

		++d; Add2(sum,-Rz,last); Rz+=Bz;
	    }
	    ReadSliceImage(paths[z],Nx,Ny,last);

	    Add2(sum,(next=Rz<=1.0)?Rz:1.0,last);

	    if ((end=z+1==Nz) || next) {
		factor=1.0/Bx/By/(Az=(end)?(double)Nz-Bz*(double)D:Bz);
		for (v=0; v<V; v++)
		for (h=0; h<H; h++) cell[v][h]=(Cell)(sum[v][h]*factor+0.5);

		factor=1.0/Ax/By/Az;
		for (v=0; v<V; v++) cell[v][H]=(Cell)(sum[v][H]*factor+0.5);

		factor=1.0/Bx/Ay/Az;
		for (h=0; h<H; h++) cell[V][h]=(Cell)(sum[V][h]*factor+0.5);

		cell[V][H]=(Cell)(sum[V][H]/Ax/Ay/Az+0.5);

		(void)sprintf(path,form,d);
		StoreImageFile(path,Nh,Nv,BPS,cell,NULL);
	    }
	}
	return 0;
}
