
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "csi.h"
#include "sif.h"

extern void	Error(),ReadSliceImage();

#define LEN	1024

int	main(argc,argv)
int	argc;
char	**argv;
{
	char	**paths,form[LEN],path[LEN],*bbs="bad block size.";
	int	Nx,Ny,Nz,BPS,Bx,By,Bz,Nh,Nv,y,v,b,d,z,h,x;
	Cell	**org,**new;

	if (argc!=5 && argc!=7)
	    Error("usage : si_sie orgDir nameFile Bxyz newDir\n"
		  "        si_sie orgDir nameFile Bx By Bz newDir");

	paths=CheckSliceImages(argv[1],argv[2],&Nx,&Ny,&Nz,&BPS);

	if (argc==5) {
	    if ((Bx=By=Bz=atoi(argv[3]))<=0) Error(bbs);
	}
	else
	    if ((Bx=atoi(argv[3]))<=0 ||
		(By=atoi(argv[4]))<=0 ||
		(Bz=atoi(argv[5]))<=0) Error(bbs);

	Nh=Nx*Bx;
	Nv=Ny*By;

#define ALLOC(type,noe)	(type *)malloc(sizeof(type)*(noe))

	if ((org=ALLOC(Cell *,(size_t)Ny))==NULL ||
	    (*org=ALLOC(Cell,(size_t)Ny*(size_t)Nh))==NULL ||
	    (new=ALLOC(Cell *,(size_t)Nv))==NULL)
	    Error("no allocatable memory for cell.");

	for (y=1; y<Ny; y++) org[y]=org[y-1]+Nh;

	for (v=y=0; y<Ny; y++, v+=By)
	    for (b=0; b<By; b++) new[v+b]=org[y];
{
	int	l=1;

	for (d=Nz*Bz-1; d>=10; d/=10) ++l;
	(void)sprintf(form,"%s/%%0%dd.tif",argv[argc-1],l);
}
	for (d=z=0; z<Nz; z++, d+=Bz) {
	    ReadSliceImage(paths[z],Nx,Ny,org);

	    for (v=y=0; y<Ny; y++, v+=By)
		for (h=Nh-1, x=Nx-1; x>=0; x--, h-=Bx)
		    for (b=0; b<Bx; b++) new[v][h-b]=org[y][x];

	    for (b=0; b<Bz; b++) {
		(void)sprintf(path,form,d+b);
		StoreImageFile(path,Nh,Nv,BPS,new,NULL);
	    }
	}
	return 0;
}
