
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "rif_rgb.h"
#include "sif.h"
#include "sif_rgb.h"

extern void	Error();

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	Nx,Ny,BPS,Bx,By,Nh,Nv,v,y,i,h,x,gray=1;
	Cell	**oR,**oG,**oB,**nR,**nG,**nB,r,g,b;
	char	*bbs="bad block size.";
	double	ratio;

	if (argc!=4 && argc!=5) Error("usage : sie_RGB orgTIFF Bxy newTIFF\n"
				      "        sie_RGB orgTIFF Bx By newTIFF");

	ReadImageFile_RGB(argv[1],&Nx,&Ny,&BPS,&oR,&oG,&oB,NULL);

	if (argc==4) {
	    if ((Bx=By=atoi(argv[2]))<=0) Error(bbs);
	}
	else
	    if ((Bx=atoi(argv[2]))<=0 ||
		(By=atoi(argv[3]))<=0) Error(bbs);

	Nh=Nx*Bx;
	Nv=Ny*By;

	if ((nR=(Cell **)malloc(sizeof(Cell *)*(size_t)Nv))==NULL ||
	    (nG=(Cell **)malloc(sizeof(Cell *)*(size_t)Nv))==NULL ||
	    (nB=(Cell **)malloc(sizeof(Cell *)*(size_t)Nv))==NULL ||
	    (*nR=(Cell *)malloc(sizeof(Cell)*(size_t)Ny*(size_t)Nh))==NULL ||
	    (*nG=(Cell *)malloc(sizeof(Cell)*(size_t)Ny*(size_t)Nh))==NULL ||
	    (*nB=(Cell *)malloc(sizeof(Cell)*(size_t)Ny*(size_t)Nh))==NULL)
	    Error("no allocatable memory for cell.");

	ratio=255.0/(double)((1<<BPS)-1);

	for (v=y=0; y<Ny; y++, v+=By) {
	    if (v!=0) {
		nR[v]=nR[v-1]+Nh; nG[v]=nG[v-1]+Nh; nB[v]=nB[v-1]+Nh;
	    }
	    for (i=1; i<By; i++) {
		nR[v+i]=nR[v]; nG[v+i]=nG[v]; nB[v+i]=nB[v];
	    }
	    for (h=x=0; x<Nx; x++, h+=Bx) {
		r=(Cell)(ratio*(double)oR[y][x]+0.5);
		g=(Cell)(ratio*(double)oG[y][x]+0.5);
		b=(Cell)(ratio*(double)oB[y][x]+0.5);
		for (i=0; i<Bx; i++) {
		    nR[v][h+i]=r; nG[v][h+i]=g; nB[v][h+i]=b;
		}
		if (gray) gray=r==g && r==b;
	    }
	}
	if (gray)
	    StoreImageFile(argv[argc-1],Nh,Nv,8,nR,NULL);
	else
	    StoreImageFile_RGB(argv[argc-1],Nh,Nv,8,nR,nG,nB,NULL);

	return 0;
}
