
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "rif.h"
#include "sif.h"

extern void	Error();

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	Nx,Ny,BPS,Bx,By,Nh,Nv,v,y,i,h,x;
	Cell	**org,**new;
	char	*bbs="bad block size.";

	if (argc!=4 && argc!=5) Error("usage : sie_gray orgTIFF Bxy newTIFF\n"
				      "        sie_gray orgTIFF Bx By newTIFF");

	ReadImageFile(argv[1],&Nx,&Ny,&BPS,&org,NULL);

	if (argc==4) {
	    if ((Bx=By=atoi(argv[2]))<=0) Error(bbs);
	}
	else
	    if ((Bx=atoi(argv[2]))<=0 ||
		(By=atoi(argv[3]))<=0) Error(bbs);

	Nh=Nx*Bx;
	Nv=Ny*By;

	if ((new=(Cell **)malloc(sizeof(Cell *)*(size_t)Nv))==NULL ||
	    (*new=(Cell *)malloc(sizeof(Cell)*(size_t)Ny*(size_t)Nh))==NULL)
	    Error("no allocatable memory for cell.");

	for (v=y=0; y<Ny; y++, v+=By) {
	    if (v!=0) new[v]=new[v-1]+Nh;

	    for (i=1; i<By; i++) new[v+i]=new[v];

	    for (h=x=0; x<Nx; x++, h+=Bx)
		for (i=0; i<Bx; i++) new[v][h+i]=org[y][x];
	}
	StoreImageFile(argv[argc-1],Nh,Nv,BPS,new,NULL);

	return 0;
}
