
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "rif_rgb.h"
#include "sif.h"
#include "sif_rgb.h"

extern void	Error();

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	Nx,Ny,BPS,Bx,By,H,Nh,V,Nv,v,h,y,x,gray=1;
	Cell	**cR,**cG,**cB,r,g,b;
	char	*bbs="bad block size.";
	double	**sR,**sG,**sB,ratio,factor;

	if (argc!=4 && argc!=5) Error("usage : sir_RGB orgTIFF Bxy newTIFF\n"
				      "        sir_RGB orgTIFF Bx By newTIFF");

	ReadImageFile_RGB(argv[1],&Nx,&Ny,&BPS,&cR,&cG,&cB,NULL);

	if (argc==4) {
	    if ((Bx=By=atoi(argv[2]))<=0) Error(bbs);
	}
	else
	    if ((Bx=atoi(argv[2]))<=0 ||
		(By=atoi(argv[3]))<=0) Error(bbs);

	Nh=(H=(Nx-1)/Bx)+1;
	Nv=(V=(Ny-1)/By)+1;

	if ((sR=(double **)malloc(sizeof(double *)*(size_t)Nv))==NULL ||
	    (sG=(double **)malloc(sizeof(double *)*(size_t)Nv))==NULL ||
	    (sB=(double **)malloc(sizeof(double *)*(size_t)Nv))==NULL ||
	(*sR=(double *)malloc(sizeof(double)*(size_t)Nv*(size_t)Nh))==NULL ||
	(*sG=(double *)malloc(sizeof(double)*(size_t)Nv*(size_t)Nh))==NULL ||
	(*sB=(double *)malloc(sizeof(double)*(size_t)Nv*(size_t)Nh))==NULL)
	    Error("no allocatable memory for sum.");

	for (v=0; v<Nv; v++) {
	    if (v!=0) {
		sR[v]=sR[v-1]+Nh; sG[v]=sG[v-1]+Nh; sB[v]=sB[v-1]+Nh;
	    }
	    for (h=0; h<Nh; h++) sR[v][h]=sG[v][h]=sB[v][h]=0.0;
	}
	for (y=0; y<Ny; y++) { v=y/By;
	for (x=0; x<Nx; x++) { h=x/Bx;
	    sR[v][h]+=(double)cR[y][x];
	    sG[v][h]+=(double)cG[y][x];
	    sB[v][h]+=(double)cB[y][x];
	}}
	ratio=255.0/(double)((1<<BPS)-1);

#define RGB(h,v)	\
	r=cR[v][h]=(Cell)(sR[v][h]*factor+0.5); \
	g=cG[v][h]=(Cell)(sG[v][h]*factor+0.5); \
	b=cB[v][h]=(Cell)(sB[v][h]*factor+0.5); if (gray) gray=r==g && r==b

	factor=ratio/(double)Bx/(double)By;
	for (v=0; v<V; v++)
	for (h=0; h<H; h++) {
	    RGB(h,v);
	}
	factor=ratio/(double)(x=(Nx-1)%Bx+1)/(double)By;
	for (v=0; v<V; v++) {
	    RGB(H,v);
	}
	factor=ratio/(double)Bx/(double)(y=(Ny-1)%By+1);
	for (h=0; h<H; h++) {
	    RGB(h,V);
	}
	factor=ratio/(double)x/(double)y; RGB(H,V);

	if (gray)
	    StoreImageFile(argv[argc-1],Nh,Nv,8,cR,NULL);
	else
	    StoreImageFile_RGB(argv[argc-1],Nh,Nv,8,cR,cG,cB,NULL);

	return 0;
}
