
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "rif.h"
#include "sif.h"

extern void	Error();

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	Nx,Ny,BPS,Bx,By,H,Nh,V,Nv,v,h,y,x;
	Cell	**cell;
	char	*bbs="bad block size.";
	double	**sum,pels;

	if (argc!=4 && argc!=5) Error("usage : sir_gray orgTIFF Bxy newTIFF\n"
				      "        sir_gray orgTIFF Bx By newTIFF");

	ReadImageFile(argv[1],&Nx,&Ny,&BPS,&cell,NULL);

	if (argc==4) {
	    if ((Bx=By=atoi(argv[2]))<=0) Error(bbs);
	}
	else
	    if ((Bx=atoi(argv[2]))<=0 ||
		(By=atoi(argv[3]))<=0) Error(bbs);

	Nh=(H=(Nx-1)/Bx)+1;
	Nv=(V=(Ny-1)/By)+1;

	if ((sum=(double **)malloc(sizeof(double *)*(size_t)Nv))==NULL ||
	    (*sum=(double *)malloc(sizeof(double)*(size_t)Nv*(size_t)Nh))==NULL)
	    Error("no allocatable memory for sum.");

	for (v=0; v<Nv; v++) {
	    if (v!=0) sum[v]=sum[v-1]+Nh;

	    for (h=0; h<Nh; h++) sum[v][h]=0.0;
	}
	for (y=0; y<Ny; y++) {
	    v=y/By; for (x=0; x<Nx; x++) sum[v][x/Bx]+=(double)cell[y][x];
	}
	pels=(double)Bx*(double)By;
	for (v=0; v<V; v++)
	for (h=0; h<H; h++) cell[v][h]=(Cell)(sum[v][h]/pels+0.5);

	pels=(double)(x=(Nx-1)%Bx+1)*(double)By;
	for (v=0; v<V; v++) cell[v][H]=(Cell)(sum[v][H]/pels+0.5);

	pels=(double)Bx*(double)(y=(Ny-1)%By+1);
	for (h=0; h<H; h++) cell[V][h]=(Cell)(sum[V][h]/pels+0.5);

	cell[V][H]=(Cell)(sum[V][H]/(double)x/(double)y+0.5);

	StoreImageFile(argv[argc-1],Nh,Nv,BPS,cell,NULL);

	return 0;
}
